﻿using System.Windows.Input;

using DevExpress.Xpf.Mvvm;

namespace TestProject
{
    /// <summary>
    /// 메인 뷰 모델
    /// </summary>
    public class MainViewModel : ViewModelBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Close Window 명령 - CloseWindowCommand

        /// <summary>
        /// Close Window 명령
        /// </summary>
        public ICommand CloseWindowCommand { get; private set; }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 현재 윈도우 서비스 - CurrentWindowService

        /// <summary>
        /// 현재 윈도우 서비스
        /// </summary>
        private ICurrentWindowService CurrentWindowService
        {
            get
            {
                return ServiceContainer.GetService<ICurrentWindowService>();
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainViewModel()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainViewModel()
        {
            CloseWindowCommand = new DelegateCommand(OnCloseWindowCommandExecute);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Close Window 명령 실행시 처리하기 - OnCloseWindowCommandExecute()

        /// <summary>
        /// Close Window 명령 실행시 처리하기
        /// </summary>
        private void OnCloseWindowCommandExecute()
        {
            CurrentWindowService.Close();
        }

        #endregion
    }
}